Public Class frmSortAndSearch
    Private _Data As New List(Of String)
    Private _Comparer As New NumericStringComparer

    Private Sub frmSortAndSearch_Load(ByVal sender As Object, _
        ByVal e As EventArgs) Handles MyBase.Load

        ' Zum Aufzeigen der Eigenheiten lexikalischer / numerischer Sortierung 
        ' ist der Ziffernbereich von 4-8 unwesentlich
        Dim Numbs As Integer() = New Integer() {1, 2, 3, 9, 10, 11}
        For Each I As Integer In Numbs
            _Data.Add(String.Concat(I, " Text"))
            For Each II As Integer In Numbs
                _Data.Add(String.Concat(I, ".", II, " Text"))
                For Each III As Integer In Numbs
                    _Data.Add(String.Concat(I, ".", II, ".", III, " Text"))
                Next
            Next
        Next
        Me.btUnSort.PerformClick()
    End Sub

    Private Sub SortOptions_Click(ByVal sender As Object, _
            ByVal e As EventArgs) Handles btUnSort.Click, btLexicalic.Click, _
            btNumeric.Click, btComparisonNumeric.Click

        Select Case True
            Case sender Is btUnSort
                Shuffle(_Data)

            Case sender Is btLexicalic
                ' (fr Inhaltsverzeichnisse unzureichende) Standard-Sortierung
                _Data.Sort()

            Case sender Is btNumeric
                ' benutzerdefinierte Sortierung mittels IComparer 
                ' implementierender Vergleicher-Klasse
                _Data.Sort(_Comparer)

            Case sender Is btComparisonNumeric
                ' benutzerdefinierte Sortierung mittels 
                ' Vergleicher(-Funktion(Comparison - Delegat))
                _Data.Sort(AddressOf modHelpers.NumericStringComparison)

        End Select
        Me.ListBox1.DataSource = Nothing
        Me.ListBox1.DataSource = _Data
        Me.ListBox1.SelectedIndices.Clear()
    End Sub

    Private Sub Search_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) _
        Handles btByMatch.Click, btBinarySearch.Click

        Me.ListBox1.SelectedIndices.Clear()
        Select Case True
            Case sender Is btByMatch
                ' Findet nur exakte bereinstimmungen
                Me.ListBox1.SelectedIndex = _
                    _Data.FindIndex(AddressOf SearchPredicate)

            Case sender Is btBinarySearch
                ' Findet auch die Werte, die dem Suchbegriff am Nchsten kommen
                FindBinary()

        End Select
    End Sub

    Private Sub Shuffle(ByVal Lst As System.Collections.IList)
        Static Rnd As New Random()
        For I As Integer = 1 To Lst.Count - 1
            ' Lst(I) mit einer zufllig aus dem bisher durchlaufenem 
            ' Bereich gewhlten vertauschen
            Dim II As Integer = Rnd.Next(I + 1)
            Dim Tmp As Object = Lst(I)
            Lst(I) = Lst(II)
            Lst(II) = Tmp
        Next
    End Sub

    ''' <summary>
    ''' Diese Function passt auf den im Framework vorgefertigten 
    ''' generischen Delegaten Predicate(Of T), und kann daher bei 
    ''' List(Of T).FindIndex() als Predicate angegeben werden
    ''' </summary>
    Private Function SearchPredicate(ByVal S As String) As Boolean
        Return S.Substring(0, S.IndexOf(" ")) = Me.TextBox1.Text
    End Function

    Private Sub FindBinary()
        ' whrend List(Of T).Sort() u.a. Comparisons akzeptiert, 
        ' bleibt BinarySearch() auf die IComparer-Schnittstelle 
        ' angewiesen. Warum?
        Dim Index As Integer = _Data.BinarySearch(Me.TextBox1.Text, _Comparer)

        ' Ein negativer Index ist das Bit-Komplement der fiktiven 
        ' **Einsortierposition**, wenn eine exakte bereinstimmung 
        ' nicht gefunden wurde.
        Select Case Index
            Case Is >= 0
                Me.ListBox1.SelectedIndex = Index

            Case -1 ' kleiner als alle
                Me.ListBox1.SelectedIndex = 0

            Case -_Data.Count ' grer als alle
                Me.ListBox1.SelectedIndex = _Data.Count - 1

            Case Else ' 2 Item markieren die Einsortierposition
                Index = Index Xor -1
                Me.ListBox1.SelectedIndices.Add(Index)
                Me.ListBox1.SelectedIndices.Add(Index - 1)

        End Select
    End Sub
End Class

